Hex Artifact Content

Artifact 43b7f533ac8672040f80276b55b1e8b5ff7251b2:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 4b  2...exit 1.fi..K
00f0: 49 54 53 48 56 45 52 53 3d 22 30 2e 30 22 0a 42  ITSHVERS="0.0".B
0100: 55 49 4c 44 44 49 52 3d 22 24 28 70 77 64 29 2f  UILDDIR="$(pwd)/
0110: 62 75 69 6c 64 2f 6b 69 74 73 68 2d 24 7b 4b 49  build/kitsh-${KI
0120: 54 53 48 56 45 52 53 7d 22 0a 4f 55 54 44 49 52  TSHVERS}".OUTDIR
0130: 3d 22 24 28 70 77 64 29 2f 6f 75 74 22 0a 49 4e  ="$(pwd)/out".IN
0140: 53 54 44 49 52 3d 22 24 28 70 77 64 29 2f 69 6e  STDIR="$(pwd)/in
0150: 73 74 22 0a 4f 54 48 45 52 50 4b 47 53 44 49 52  st".OTHERPKGSDIR
0160: 3d 22 24 28 70 77 64 29 2f 2e 2e 2f 22 0a 65 78  ="$(pwd)/../".ex
0170: 70 6f 72 74 20 4b 49 54 53 48 56 45 52 53 20 42  port KITSHVERS B
0180: 55 49 4c 44 44 49 52 20 4f 55 54 44 49 52 20 49  UILDDIR OUTDIR I
0190: 4e 53 54 44 49 52 20 4f 54 48 45 52 50 4b 47 53  NSTDIR OTHERPKGS
01a0: 44 49 52 0a 0a 69 66 20 5b 20 2d 7a 20 22 24 7b  DIR..if [ -z "${
01b0: 45 4e 41 42 4c 45 43 4f 4d 50 52 45 53 53 49 4f  ENABLECOMPRESSIO
01c0: 4e 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 45 4e 41  N}" ]; then..ENA
01d0: 42 4c 45 43 4f 4d 50 52 45 53 53 49 4f 4e 3d 22  BLECOMPRESSION="
01e0: 31 22 0a 66 69 0a 65 78 70 6f 72 74 20 45 4e 41  1".fi.export ENA
01f0: 42 4c 45 43 4f 4d 50 52 45 53 53 49 4f 4e 0a 0a  BLECOMPRESSION..
0200: 72 6d 20 2d 72 66 20 27 62 75 69 6c 64 27 20 27  rm -rf 'build' '
0210: 6f 75 74 27 20 27 69 6e 73 74 27 0a 6d 6b 64 69  out' 'inst'.mkdi
0220: 72 20 27 6f 75 74 27 20 27 69 6e 73 74 27 20 7c  r 'out' 'inst' |
0230: 7c 20 65 78 69 74 20 31 0a 0a 0a 28 0a 09 63 70  | exit 1...(..cp
0240: 20 2d 72 20 27 62 75 69 6c 64 73 72 63 27 20 27   -r 'buildsrc' '
0250: 62 75 69 6c 64 27 0a 09 63 64 20 22 24 7b 42 55  build'..cd "${BU
0260: 49 4c 44 44 49 52 7d 22 20 7c 7c 20 65 78 69 74  ILDDIR}" || exit
0270: 20 31 0a 0a 09 23 20 46 69 78 20 75 70 20 61 72   1...# Fix up ar
0280: 63 68 69 76 65 73 20 74 68 61 74 20 54 63 6c 20  chives that Tcl 
0290: 67 65 74 73 20 77 72 6f 6e 67 0a 09 66 6f 72 20  gets wrong..for 
02a0: 61 72 63 68 69 76 65 20 69 6e 20 2e 2e 2f 2e 2e  archive in ../..
02b0: 2f 2e 2e 2f 74 63 6c 2f 69 6e 73 74 2f 6c 69 62  /../tcl/inst/lib
02c0: 2f 64 64 65 2a 2f 74 63 6c 64 64 65 2a 2e 61 20  /dde*/tcldde*.a 
02d0: 2e 2e 2f 2e 2e 2f 2e 2e 2f 74 63 6c 2f 69 6e 73  ../../../tcl/ins
02e0: 74 2f 6c 69 62 2f 72 65 67 2a 2f 74 63 6c 72 65  t/lib/reg*/tclre
02f0: 67 2a 2e 61 3b 20 64 6f 0a 09 09 69 66 20 5b 20  g*.a; do...if [ 
0300: 21 20 2d 66 20 22 24 7b 61 72 63 68 69 76 65 7d  ! -f "${archive}
0310: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 63 6f 6e  " ]; then....con
0320: 74 69 6e 75 65 0a 09 09 66 69 0a 0a 09 09 72 6d  tinue...fi....rm
0330: 20 2d 72 66 20 5f 5f 54 45 4d 50 5f 5f 0a 09 09   -rf __TEMP__...
0340: 28 0a 09 09 09 6d 6b 64 69 72 20 5f 5f 54 45 4d  (....mkdir __TEM
0350: 50 5f 5f 20 7c 7c 20 65 78 69 74 20 31 0a 09 09  P__ || exit 1...
0360: 09 63 64 20 5f 5f 54 45 4d 50 5f 5f 0a 0a 09 09  .cd __TEMP__....
0370: 09 23 23 20 50 61 74 63 68 20 61 72 63 68 69 76  .## Patch archiv
0380: 65 20 6e 61 6d 65 0a 09 09 09 61 72 63 68 69 76  e name....archiv
0390: 65 3d 22 2e 2e 2f 24 7b 61 72 63 68 69 76 65 7d  e="../${archive}
03a0: 22 0a 0a 09 09 09 22 24 7b 41 52 3a 2d 61 72 7d  "....."${AR:-ar}
03b0: 22 20 78 20 22 24 7b 61 72 63 68 69 76 65 7d 22  " x "${archive}"
03c0: 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09 09 72   || exit 1.....r
03d0: 6d 20 2d 66 20 22 24 7b 61 72 63 68 69 76 65 7d  m -f "${archive}
03e0: 22 0a 0a 09 09 09 22 24 7b 41 52 3a 2d 61 72 7d  "....."${AR:-ar}
03f0: 22 20 63 72 20 22 24 7b 61 72 63 68 69 76 65 7d  " cr "${archive}
0400: 22 20 2a 2e 6f 20 7c 7c 20 65 78 69 74 20 31 0a  " *.o || exit 1.
0410: 09 09 09 22 24 7b 52 41 4e 4c 49 42 3a 2d 72 61  ..."${RANLIB:-ra
0420: 6e 6c 69 62 7d 22 20 22 24 7b 61 72 63 68 69 76  nlib}" "${archiv
0430: 65 7d 22 20 7c 7c 20 74 72 75 65 0a 09 09 29 0a  e}" || true...).
0440: 09 64 6f 6e 65 0a 0a 09 23 20 43 6c 65 61 6e 75  .done...# Cleanu
0450: 70 2c 20 6a 75 73 74 20 69 6e 63 61 73 65 20 74  p, just incase t
0460: 68 65 20 69 6e 63 6f 6d 69 6e 67 20 64 69 72 65  he incoming dire
0470: 63 74 6f 72 79 20 77 61 73 20 6e 6f 74 20 70 72  ctory was not pr
0480: 65 2d 63 6c 65 61 6e 65 64 0a 09 24 7b 4d 41 4b  e-cleaned..${MAK
0490: 45 3a 2d 6d 61 6b 65 7d 20 64 69 73 74 63 6c 65  E:-make} distcle
04a0: 61 6e 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e  an >/dev/null 2>
04b0: 2f 64 65 76 2f 6e 75 6c 6c 0a 09 72 6d 20 2d 72  /dev/null..rm -r
04c0: 66 20 27 73 74 61 72 70 61 63 6b 2e 76 66 73 27  f 'starpack.vfs'
04d0: 0a 0a 09 23 20 43 72 65 61 74 65 20 56 46 53 20  ...# Create VFS 
04e0: 64 69 72 65 63 74 6f 72 79 0a 09 6d 6b 64 69 72  directory..mkdir
04f0: 20 22 73 74 61 72 70 61 63 6b 2e 76 66 73 22 0a   "starpack.vfs".
0500: 09 6d 6b 64 69 72 20 22 73 74 61 72 70 61 63 6b  .mkdir "starpack
0510: 2e 76 66 73 2f 6c 69 62 22 0a 0a 09 23 23 20 43  .vfs/lib"...## C
0520: 6f 70 79 20 69 6e 20 61 6c 6c 20 62 75 69 6c 74  opy in all built
0530: 20 64 69 72 65 63 74 6f 72 69 65 73 0a 09 63 70   directories..cp
0540: 20 2d 72 20 22 24 7b 4f 54 48 45 52 50 4b 47 53   -r "${OTHERPKGS
0550: 44 49 52 7d 22 2f 2a 2f 6f 75 74 2f 2a 20 27 73  DIR}"/*/out/* 's
0560: 74 61 72 70 61 63 6b 2e 76 66 73 2f 27 0a 0a 09  tarpack.vfs/'...
0570: 23 23 20 52 65 6e 61 6d 65 20 74 68 65 20 22 76  ## Rename the "v
0580: 66 73 22 20 70 61 63 6b 61 67 65 20 64 69 72 65  fs" package dire
0590: 63 74 6f 72 79 20 74 6f 20 77 68 61 74 20 22 62  ctory to what "b
05a0: 6f 6f 74 2e 74 63 6c 22 20 65 78 70 65 63 74 73  oot.tcl" expects
05b0: 0a 09 6d 76 20 27 73 74 61 72 70 61 63 6b 2e 76  ..mv 'starpack.v
05c0: 66 73 2f 6c 69 62 27 2f 76 66 73 2a 20 27 73 74  fs/lib'/vfs* 'st
05d0: 61 72 70 61 63 6b 2e 76 66 73 2f 6c 69 62 2f 76  arpack.vfs/lib/v
05e0: 66 73 27 0a 0a 09 23 23 20 49 6e 73 74 61 6c 6c  fs'...## Install
05f0: 20 22 62 6f 6f 74 2e 74 63 6c 22 0a 09 63 70 20   "boot.tcl"..cp 
0600: 27 62 6f 6f 74 2e 74 63 6c 27 20 27 73 74 61 72  'boot.tcl' 'star
0610: 70 61 63 6b 2e 76 66 73 2f 27 0a 0a 09 23 20 46  pack.vfs/'...# F
0620: 69 67 75 72 65 20 6f 75 74 20 69 66 20 7a 6c 69  igure out if zli
0630: 62 20 63 6f 6d 70 69 6c 65 64 20 28 69 66 20 6e  b compiled (if n
0640: 6f 74 2c 20 74 68 65 20 73 79 73 74 65 6d 20 7a  ot, the system z
0650: 6c 69 62 20 77 69 6c 6c 20 62 65 20 75 73 65 64  lib will be used
0660: 20 61 6e 64 20 77 65 0a 09 23 20 77 69 6c 6c 20   and we..# will 
0670: 6e 65 65 64 20 74 6f 20 68 61 76 65 20 74 68 61  need to have tha
0680: 74 20 70 72 65 73 65 6e 74 29 0a 09 5a 4c 49 42  t present)..ZLIB
0690: 44 49 52 3d 22 24 28 63 64 20 22 24 7b 4f 54 48  DIR="$(cd "${OTH
06a0: 45 52 50 4b 47 53 44 49 52 7d 2f 7a 6c 69 62 2f  ERPKGSDIR}/zlib/
06b0: 69 6e 73 74 22 20 32 3e 2f 64 65 76 2f 6e 75 6c  inst" 2>/dev/nul
06c0: 6c 20 26 26 20 70 77 64 29 22 0a 09 65 78 70 6f  l && pwd)"..expo
06d0: 72 74 20 5a 4c 49 42 44 49 52 0a 09 69 66 20 5b  rt ZLIBDIR..if [
06e0: 20 2d 7a 20 22 24 7b 5a 4c 49 42 44 49 52 7d 22   -z "${ZLIBDIR}"
06f0: 20 2d 6f 20 21 20 2d 66 20 22 24 7b 5a 4c 49 42   -o ! -f "${ZLIB
0700: 44 49 52 7d 2f 6c 69 62 2f 6c 69 62 7a 2e 61 22  DIR}/lib/libz.a"
0710: 20 5d 3b 20 74 68 65 6e 0a 09 09 75 6e 73 65 74   ]; then...unset
0720: 20 5a 4c 49 42 44 49 52 0a 09 66 69 0a 0a 09 23   ZLIBDIR..fi...#
0730: 20 43 6f 70 79 20 75 73 65 72 20 73 70 65 63 69   Copy user speci
0740: 66 69 65 64 20 6b 69 74 2e 72 63 20 61 6e 64 20  fied kit.rc and 
0750: 6b 69 74 2e 69 63 6f 20 69 6e 20 74 6f 20 62 75  kit.ico in to bu
0760: 69 6c 64 20 64 69 72 65 63 74 6f 72 79 2c 20 69  ild directory, i
0770: 66 20 66 6f 75 6e 64 0a 09 63 70 20 22 24 7b 4b  f found..cp "${K
0780: 49 54 43 52 45 41 54 4f 52 5f 49 43 4f 4e 7d 22  ITCREATOR_ICON}"
0790: 20 22 24 7b 42 55 49 4c 44 44 49 52 7d 2f 6b 69   "${BUILDDIR}/ki
07a0: 74 2e 69 63 6f 22 0a 09 63 70 20 22 24 7b 4b 49  t.ico"..cp "${KI
07b0: 54 43 52 45 41 54 4f 52 5f 52 43 7d 22 20 22 24  TCREATOR_RC}" "$
07c0: 7b 42 55 49 4c 44 44 49 52 7d 2f 6b 69 74 2e 72  {BUILDDIR}/kit.r
07d0: 63 22 0a 0a 09 23 20 49 6e 63 6c 75 64 65 20 65  c"...# Include e
07e0: 78 74 72 61 20 6f 62 6a 65 63 74 73 20 61 73 20  xtra objects as 
07f0: 72 65 71 75 69 72 65 64 0a 09 23 23 20 49 6e 69  required..## Ini
0800: 74 69 61 6c 69 7a 65 20 6c 69 73 74 20 6f 66 20  tialize list of 
0810: 65 78 74 72 61 20 6f 62 6a 65 63 74 73 0a 09 45  extra objects..E
0820: 58 54 52 41 5f 4f 42 4a 53 3d 22 22 0a 09 65 78  XTRA_OBJS=""..ex
0830: 70 6f 72 74 20 45 58 54 52 41 5f 4f 42 4a 53 0a  port EXTRA_OBJS.
0840: 0a 09 23 23 20 54 6b 20 52 65 73 6f 75 72 63 65  ..## Tk Resource
0850: 73 20 28 6e 65 65 64 65 64 20 66 6f 72 20 57 69  s (needed for Wi
0860: 6e 33 32 20 73 75 70 70 6f 72 74 29 20 2d 2d 20  n32 support) -- 
0870: 72 65 6d 6f 76 65 20 6b 69 74 2d 66 6f 75 6e 64  remove kit-found
0880: 20 72 65 73 6f 75 72 63 65 73 20 74 6f 20 70 72   resources to pr
0890: 65 76 65 6e 74 20 74 68 65 20 73 79 6d 62 6f 6c  event the symbol
08a0: 73 20 66 72 6f 6d 20 62 65 69 6e 67 20 69 6e 20  s from being in 
08b0: 63 6f 6e 66 6c 69 63 74 0a 09 54 4b 44 49 52 3d  conflict..TKDIR=
08c0: 22 24 28 63 64 20 22 24 7b 4f 54 48 45 52 50 4b  "$(cd "${OTHERPK
08d0: 47 53 44 49 52 7d 2f 74 6b 2f 69 6e 73 74 22 20  GSDIR}/tk/inst" 
08e0: 26 26 20 70 77 64 29 22 0a 09 54 4b 52 53 52 43  && pwd)"..TKRSRC
08f0: 3d 22 24 7b 54 4b 44 49 52 7d 2f 6c 69 62 2f 74  ="${TKDIR}/lib/t
0900: 6b 62 61 73 65 2e 72 65 73 2e 6f 22 0a 09 69 66  kbase.res.o"..if
0910: 20 5b 20 2d 6e 20 22 24 7b 54 4b 44 49 52 7d 22   [ -n "${TKDIR}"
0920: 20 2d 61 20 2d 66 20 22 24 7b 54 4b 52 53 52 43   -a -f "${TKRSRC
0930: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 45 58 54  }" ]; then...EXT
0940: 52 41 5f 4f 42 4a 53 3d 22 24 7b 45 58 54 52 41  RA_OBJS="${EXTRA
0950: 5f 4f 42 4a 53 7d 20 24 7b 54 4b 52 53 52 43 7d  _OBJS} ${TKRSRC}
0960: 22 0a 0a 09 09 65 63 68 6f 20 27 20 2a 2a 2a 20  "....echo ' *** 
0970: 52 65 6d 6f 76 69 6e 67 20 22 6b 69 74 2e 72 63  Removing "kit.rc
0980: 22 20 73 69 6e 63 65 20 77 65 20 68 61 76 65 20  " since we have 
0990: 54 6b 20 77 69 74 68 20 69 74 73 20 6f 77 6e 20  Tk with its own 
09a0: 72 65 73 6f 75 72 63 65 20 66 69 6c 65 27 0a 0a  resource file'..
09b0: 09 09 72 6d 20 2d 66 20 22 24 7b 42 55 49 4c 44  ..rm -f "${BUILD
09c0: 44 49 52 7d 2f 6b 69 74 2e 72 63 22 0a 09 66 69  DIR}/kit.rc"..fi
09d0: 0a 0a 09 23 20 44 65 74 65 72 6d 69 6e 65 20 69  ...# Determine i
09e0: 66 20 74 61 72 67 65 74 20 69 73 20 4b 69 74 44  f target is KitD
09f0: 4c 4c 20 6f 72 20 4b 69 74 53 48 0a 09 69 66 20  LL or KitSH..if 
0a00: 5b 20 22 24 7b 4b 49 54 54 41 52 47 45 54 7d 22  [ "${KITTARGET}"
0a10: 20 3d 20 22 6b 69 74 64 6c 6c 22 20 5d 3b 20 74   = "kitdll" ]; t
0a20: 68 65 6e 0a 09 09 43 4f 4e 46 49 47 55 52 45 45  hen...CONFIGUREE
0a30: 58 54 52 41 3d 22 24 7b 43 4f 4e 46 49 47 55 52  XTRA="${CONFIGUR
0a40: 45 45 58 54 52 41 7d 20 2d 2d 65 6e 61 62 6c 65  EEXTRA} --enable
0a50: 2d 6b 69 74 64 6c 6c 22 0a 09 66 69 0a 0a 09 23  -kitdll"..fi...#
0a60: 20 43 6f 6d 70 69 6c 65 20 4b 69 74 0a 09 69 66   Compile Kit..if
0a70: 20 5b 20 2d 7a 20 22 24 7b 5a 4c 49 42 44 49 52   [ -z "${ZLIBDIR
0a80: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63 68  }" ]; then...ech
0a90: 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 2e 2f 63 6f  o "Running: ./co
0aa0: 6e 66 69 67 75 72 65 20 2d 2d 77 69 74 68 2d 74  nfigure --with-t
0ab0: 63 6c 3d 5c 22 24 7b 54 43 4c 43 4f 4e 46 49 47  cl=\"${TCLCONFIG
0ac0: 44 49 52 7d 5c 22 20 24 7b 43 4f 4e 46 49 47 55  DIR}\" ${CONFIGU
0ad0: 52 45 45 58 54 52 41 7d 22 0a 0a 09 09 2e 2f 63  REEXTRA}"...../c
0ae0: 6f 6e 66 69 67 75 72 65 20 2d 2d 77 69 74 68 2d  onfigure --with-
0af0: 74 63 6c 3d 22 24 7b 54 43 4c 43 4f 4e 46 49 47  tcl="${TCLCONFIG
0b00: 44 49 52 7d 22 20 24 7b 43 4f 4e 46 49 47 55 52  DIR}" ${CONFIGUR
0b10: 45 45 58 54 52 41 7d 0a 09 65 6c 73 65 0a 09 09  EEXTRA}..else...
0b20: 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 2e  echo "Running: .
0b30: 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d 77 69 74  /configure --wit
0b40: 68 2d 74 63 6c 3d 5c 22 24 7b 54 43 4c 43 4f 4e  h-tcl=\"${TCLCON
0b50: 46 49 47 44 49 52 7d 5c 22 20 2d 2d 77 69 74 68  FIGDIR}\" --with
0b60: 2d 7a 6c 69 62 3d 5c 22 24 7b 5a 4c 49 42 44 49  -zlib=\"${ZLIBDI
0b70: 52 7d 5c 22 20 24 7b 43 4f 4e 46 49 47 55 52 45  R}\" ${CONFIGURE
0b80: 45 58 54 52 41 7d 22 0a 0a 09 09 2e 2f 63 6f 6e  EXTRA}"...../con
0b90: 66 69 67 75 72 65 20 2d 2d 77 69 74 68 2d 74 63  figure --with-tc
0ba0: 6c 3d 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49  l="${TCLCONFIGDI
0bb0: 52 7d 22 20 2d 2d 77 69 74 68 2d 7a 6c 69 62 3d  R}" --with-zlib=
0bc0: 22 24 7b 5a 4c 49 42 44 49 52 7d 22 20 24 7b 43  "${ZLIBDIR}" ${C
0bd0: 4f 4e 46 49 47 55 52 45 45 58 54 52 41 7d 0a 09  ONFIGUREEXTRA}..
0be0: 66 69 0a 0a 09 65 63 68 6f 20 22 52 75 6e 6e 69  fi...echo "Runni
0bf0: 6e 67 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65  ng: ${MAKE:-make
0c00: 7d 20 54 43 4c 53 48 5f 4e 41 54 49 56 45 3d 5c  } TCLSH_NATIVE=\
0c10: 22 24 7b 54 43 4c 53 48 5f 4e 41 54 49 56 45 7d  "${TCLSH_NATIVE}
0c20: 5c 22 22 0a 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b  \""..${MAKE:-mak
0c30: 65 7d 20 54 43 4c 53 48 5f 4e 41 54 49 56 45 3d  e} TCLSH_NATIVE=
0c40: 22 24 7b 54 43 4c 53 48 5f 4e 41 54 49 56 45 7d  "${TCLSH_NATIVE}
0c50: 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 23 20  " || exit 1...# 
0c60: 53 74 72 69 70 20 74 68 65 20 6b 69 74 20 6f 66  Strip the kit of
0c70: 20 61 6c 6c 20 73 79 6d 62 6f 6c 73 2c 20 69 66   all symbols, if
0c80: 20 70 6f 73 73 69 62 6c 65 0a 09 22 24 7b 53 54   possible.."${ST
0c90: 52 49 50 3a 2d 73 74 72 69 70 7d 22 20 6b 69 74  RIP:-strip}" kit
0ca0: 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64   >/dev/null 2>/d
0cb0: 65 76 2f 6e 75 6c 6c 0a 09 22 24 7b 53 54 52 49  ev/null.."${STRI
0cc0: 50 3a 2d 73 74 72 69 70 7d 22 20 2d 67 20 6c 69  P:-strip}" -g li
0cd0: 62 74 63 6c 6b 69 74 2a 20 3e 2f 64 65 76 2f 6e  btclkit* >/dev/n
0ce0: 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a  ull 2>/dev/null.
0cf0: 0a 09 23 20 46 69 78 20 75 70 20 57 69 6e 33 32  ..# Fix up Win32
0d00: 20 44 4c 4c 20 6e 61 6d 65 73 0a 09 23 23 20 2e   DLL names..## .
0d10: 44 4c 4c 2e 41 20 2d 3e 20 2e 4c 49 42 0a 09 66  DLL.A -> .LIB..f
0d20: 6f 72 20 66 69 6c 65 20 69 6e 20 6c 69 62 74 63  or file in libtc
0d30: 6c 6b 69 74 2a 2e 64 6c 6c 2e 61 3b 20 64 6f 0a  lkit*.dll.a; do.
0d40: 09 09 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 66  ..if [ ! -f "${f
0d50: 69 6c 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09  ile}" ]; then...
0d60: 09 63 6f 6e 74 69 6e 75 65 0a 09 09 66 69 0a 0a  .continue...fi..
0d70: 09 09 6e 65 77 66 69 6c 65 3d 22 24 28 62 61 73  ..newfile="$(bas
0d80: 65 6e 61 6d 65 20 22 24 7b 66 69 6c 65 7d 22 20  ename "${file}" 
0d90: 2e 64 6c 6c 2e 61 29 2e 6c 69 62 22 0a 09 09 6d  .dll.a).lib"...m
0da0: 76 20 22 24 7b 66 69 6c 65 7d 22 20 22 24 7b 6e  v "${file}" "${n
0db0: 65 77 66 69 6c 65 7d 22 0a 09 64 6f 6e 65 0a 0a  ewfile}"..done..
0dc0: 09 23 23 20 2e 44 4c 4c 2e 44 45 46 20 2d 3e 20  .## .DLL.DEF -> 
0dd0: 2e 44 45 46 0a 09 66 6f 72 20 66 69 6c 65 20 69  .DEF..for file i
0de0: 6e 20 6c 69 62 74 63 6c 6b 69 74 2a 2e 64 6c 6c  n libtclkit*.dll
0df0: 2e 64 65 66 3b 20 64 6f 0a 09 09 69 66 20 5b 20  .def; do...if [ 
0e00: 21 20 2d 66 20 22 24 7b 66 69 6c 65 7d 22 20 5d  ! -f "${file}" ]
0e10: 3b 20 74 68 65 6e 0a 09 09 09 63 6f 6e 74 69 6e  ; then....contin
0e20: 75 65 0a 09 09 66 69 0a 0a 09 09 6e 65 77 66 69  ue...fi....newfi
0e30: 6c 65 3d 22 24 28 62 61 73 65 6e 61 6d 65 20 22  le="$(basename "
0e40: 24 7b 66 69 6c 65 7d 22 20 2e 64 6c 6c 2e 64 65  ${file}" .dll.de
0e50: 66 29 2e 64 65 66 22 0a 09 09 6d 76 20 22 24 7b  f).def"...mv "${
0e60: 66 69 6c 65 7d 22 20 22 24 7b 6e 65 77 66 69 6c  file}" "${newfil
0e70: 65 7d 22 0a 09 64 6f 6e 65 0a 0a 09 23 20 44 65  e}"..done...# De
0e80: 74 65 72 6d 69 6e 65 20 6e 61 6d 65 20 6f 66 20  termine name of 
0e90: 63 72 65 61 74 65 64 20 6b 69 74 0a 09 4b 49 54  created kit..KIT
0ea0: 54 41 52 47 45 54 5f 4e 41 4d 45 3d 27 5f 5f 65  TARGET_NAME='__e
0eb0: 72 72 6f 72 5f 5f 27 0a 09 69 66 20 5b 20 22 24  rror__'..if [ "$
0ec0: 7b 4b 49 54 54 41 52 47 45 54 7d 22 20 3d 20 22  {KITTARGET}" = "
0ed0: 6b 69 74 64 6c 6c 22 20 5d 3b 20 74 68 65 6e 0a  kitdll" ]; then.
0ee0: 09 09 23 23 20 46 69 6e 64 20 74 68 65 20 6c 69  ..## Find the li
0ef0: 62 72 61 72 79 20 63 72 65 61 74 65 64 0a 09 09  brary created...
0f00: 66 6f 72 20 63 68 6b 6b 69 74 74 61 72 67 65 74  for chkkittarget
0f10: 20 69 6e 20 6c 69 62 74 63 6c 6b 69 74 2a 2e 2a   in libtclkit*.*
0f20: 3b 20 64 6f 0a 09 09 09 69 66 20 5b 20 21 20 2d  ; do....if [ ! -
0f30: 66 20 22 24 7b 63 68 6b 6b 69 74 74 61 72 67 65  f "${chkkittarge
0f40: 74 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09  t}" ]; then.....
0f50: 63 6f 6e 74 69 6e 75 65 0a 09 09 09 66 69 0a 0a  continue....fi..
0f60: 09 09 09 69 66 20 65 63 68 6f 20 22 24 7b 63 68  ...if echo "${ch
0f70: 6b 6b 69 74 74 61 72 67 65 74 7d 22 20 7c 20 65  kkittarget}" | e
0f80: 67 72 65 70 20 27 5c 2e 28 6c 69 62 7c 64 65 66  grep '\.(lib|def
0f90: 7c 61 29 24 27 3b 20 74 68 65 6e 0a 09 09 09 09  |a)$'; then.....
0fa0: 63 6f 6e 74 69 6e 75 65 0a 09 09 09 66 69 0a 0a  continue....fi..
0fb0: 09 09 09 4b 49 54 54 41 52 47 45 54 5f 4e 41 4d  ...KITTARGET_NAM
0fc0: 45 3d 22 24 7b 63 68 6b 6b 69 74 74 61 72 67 65  E="${chkkittarge
0fd0: 74 7d 22 0a 0a 09 09 09 62 72 65 61 6b 0a 09 09  t}".....break...
0fe0: 64 6f 6e 65 0a 0a 09 09 23 23 20 41 6c 73 6f 20  done....## Also 
0ff0: 63 72 65 61 74 65 20 61 6e 20 65 78 65 63 75 74  create an execut
1000: 61 62 6c 65 20 6e 61 6d 65 64 20 22 6b 69 74 22  able named "kit"
1010: 20 73 6f 20 74 68 61 74 20 77 65 20 63 61 6e 20   so that we can 
1020: 72 75 6e 20 69 74 20 6c 61 74 65 72 0a 09 09 24  run it later...$
1030: 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20 74 63 6c  {MAKE:-make} tcl
1040: 73 68 0a 09 09 6d 76 20 74 63 6c 73 68 20 6b 69  sh...mv tclsh ki
1050: 74 0a 09 65 6c 73 65 0a 09 09 23 23 20 54 68 65  t..else...## The
1060: 20 65 78 65 63 75 74 61 62 6c 65 20 69 73 20 61   executable is a
1070: 6c 77 61 79 73 20 6e 61 6d 65 64 20 22 6b 69 74  lways named "kit
1080: 22 0a 09 09 4b 49 54 54 41 52 47 45 54 5f 4e 41  "...KITTARGET_NA
1090: 4d 45 3d 27 6b 69 74 27 0a 09 66 69 0a 09 65 78  ME='kit'..fi..ex
10a0: 70 6f 72 74 20 4b 49 54 54 41 52 47 45 54 5f 4e  port KITTARGET_N
10b0: 41 4d 45 0a 0a 09 69 66 20 5b 20 22 78 24 7b 4b  AME...if [ "x${K
10c0: 49 54 54 41 52 47 45 54 5f 4e 41 4d 45 7d 22 20  ITTARGET_NAME}" 
10d0: 3d 20 27 78 5f 5f 65 72 72 6f 72 5f 5f 27 20 5d  = 'x__error__' ]
10e0: 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f 20 22 46  ; then...echo "F
10f0: 61 69 6c 65 64 20 74 6f 20 6c 6f 63 61 74 65 20  ailed to locate 
1100: 6b 69 74 20 74 61 72 67 65 74 21 22 20 3e 26 32  kit target!" >&2
1110: 0a 0a 09 09 65 78 69 74 20 31 0a 09 66 69 0a 0a  ....exit 1..fi..
1120: 09 23 20 49 6e 74 61 6c 6c 20 56 46 53 20 6f 6e  .# Intall VFS on
1130: 74 6f 20 6b 69 74 0a 09 23 23 20 44 65 74 65 72  to kit..## Deter
1140: 6d 69 6e 65 20 69 66 20 77 65 20 68 61 76 65 20  mine if we have 
1150: 61 20 54 63 6c 6b 69 74 20 74 6f 20 64 6f 20 74  a Tclkit to do t
1160: 68 69 73 20 77 6f 72 6b 0a 09 54 43 4c 4b 49 54  his work..TCLKIT
1170: 3d 22 24 7b 54 43 4c 4b 49 54 3a 2d 74 63 6c 6b  ="${TCLKIT:-tclk
1180: 69 74 7d 22 0a 09 69 66 20 65 63 68 6f 20 27 65  it}"..if echo 'e
1190: 78 69 74 20 30 27 20 7c 20 22 24 7b 54 43 4c 4b  xit 0' | "${TCLK
11a0: 49 54 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  IT}" >/dev/null 
11b0: 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65  2>/dev/null; the
11c0: 6e 0a 09 09 23 23 20 49 6e 73 74 61 6c 6c 20 75  n...## Install u
11d0: 73 69 6e 67 20 65 78 69 73 74 69 6e 67 20 54 63  sing existing Tc
11e0: 6c 6b 69 74 0a 09 09 23 23 23 20 43 61 6c 6c 20  lkit...### Call 
11f0: 69 6e 73 74 61 6c 6c 65 72 0a 09 09 65 63 68 6f  installer...echo
1200: 20 22 52 75 6e 6e 69 6e 67 3a 20 5c 22 24 7b 54   "Running: \"${T
1210: 43 4c 4b 49 54 7d 5c 22 20 69 6e 73 74 61 6c 6c  CLKIT}\" install
1220: 76 66 73 2e 74 63 6c 20 5c 22 24 7b 4b 49 54 54  vfs.tcl \"${KITT
1230: 41 52 47 45 54 5f 4e 41 4d 45 7d 5c 22 20 73 74  ARGET_NAME}\" st
1240: 61 72 70 61 63 6b 2e 76 66 73 20 5c 22 24 7b 45  arpack.vfs \"${E
1250: 4e 41 42 4c 45 43 4f 4d 50 52 45 53 53 49 4f 4e  NABLECOMPRESSION
1260: 7d 5c 22 22 0a 09 09 22 24 7b 54 43 4c 4b 49 54  }\""..."${TCLKIT
1270: 7d 22 20 69 6e 73 74 61 6c 6c 76 66 73 2e 74 63  }" installvfs.tc
1280: 6c 20 22 24 7b 4b 49 54 54 41 52 47 45 54 5f 4e  l "${KITTARGET_N
1290: 41 4d 45 7d 22 20 73 74 61 72 70 61 63 6b 2e 76  AME}" starpack.v
12a0: 66 73 20 22 24 7b 45 4e 41 42 4c 45 43 4f 4d 50  fs "${ENABLECOMP
12b0: 52 45 53 53 49 4f 4e 7d 22 20 7c 7c 20 65 78 69  RESSION}" || exi
12c0: 74 20 31 0a 09 65 6c 73 65 0a 09 09 23 23 20 42  t 1..else...## B
12d0: 6f 6f 74 73 74 72 61 70 20 28 63 61 6e 6e 6f 74  ootstrap (cannot
12e0: 20 63 72 6f 73 73 2d 63 6f 6d 70 69 6c 65 29 0a   cross-compile).
12f0: 09 09 23 23 23 20 43 61 6c 6c 20 69 6e 73 74 61  ..### Call insta
1300: 6c 6c 65 72 0a 09 09 63 70 20 6b 69 74 20 72 75  ller...cp kit ru
1310: 6e 6b 69 74 0a 09 09 65 63 68 6f 20 22 73 65 74  nkit...echo "set
1320: 20 61 72 67 76 20 5b 6c 69 73 74 20 7b 24 7b 4b   argv [list {${K
1330: 49 54 54 41 52 47 45 54 5f 4e 41 4d 45 7d 7d 20  ITTARGET_NAME}} 
1340: 73 74 61 72 70 61 63 6b 2e 76 66 73 20 7b 24 7b  starpack.vfs {${
1350: 45 4e 41 42 4c 45 43 4f 4d 50 52 45 53 53 49 4f  ENABLECOMPRESSIO
1360: 4e 7d 7d 5d 22 20 3e 20 73 65 74 75 70 2e 74 63  N}}]" > setup.tc
1370: 6c 0a 09 09 65 63 68 6f 20 27 69 66 20 7b 5b 63  l...echo 'if {[c
1380: 61 74 63 68 20 7b 20 63 6c 6f 63 6b 20 73 65 63  atch { clock sec
1390: 6f 6e 64 73 20 7d 5d 7d 20 7b 20 70 72 6f 63 20  onds }]} { proc 
13a0: 63 6c 6f 63 6b 20 61 72 67 73 20 7b 20 72 65 74  clock args { ret
13b0: 75 72 6e 20 30 20 7d 20 7d 27 20 3e 3e 20 73 65  urn 0 } }' >> se
13c0: 74 75 70 2e 74 63 6c 0a 09 09 65 63 68 6f 20 27  tup.tcl...echo '
13d0: 73 6f 75 72 63 65 20 69 6e 73 74 61 6c 6c 76 66  source installvf
13e0: 73 2e 74 63 6c 27 20 3e 3e 20 73 65 74 75 70 2e  s.tcl' >> setup.
13f0: 74 63 6c 0a 0a 09 09 65 63 68 6f 20 27 52 75 6e  tcl....echo 'Run
1400: 6e 69 6e 67 3a 20 65 63 68 6f 20 7c 20 2e 2f 72  ning: echo | ./r
1410: 75 6e 6b 69 74 27 0a 09 09 65 63 68 6f 20 7c 20  unkit'...echo | 
1420: 2e 2f 72 75 6e 6b 69 74 20 73 65 74 75 70 2e 74  ./runkit setup.t
1430: 63 6c 20 7c 7c 20 65 78 69 74 20 31 0a 09 66 69  cl || exit 1..fi
1440: 0a 0a 09 23 20 43 6c 65 61 6e 75 70 0a 09 69 66  ...# Cleanup..if
1450: 20 5b 20 22 24 7b 4b 49 54 54 41 52 47 45 54 7d   [ "${KITTARGET}
1460: 22 20 3d 20 22 6b 69 74 64 6c 6c 22 20 5d 3b 20  " = "kitdll" ]; 
1470: 74 68 65 6e 0a 09 09 23 23 20 52 65 6d 6f 76 65  then...## Remove
1480: 20 62 75 69 6c 74 20 69 6e 74 65 72 70 72 65 74   built interpret
1490: 65 72 73 20 69 66 20 77 65 20 61 72 65 20 62 75  ers if we are bu
14a0: 69 6c 64 69 6e 67 20 4b 69 74 44 4c 4c 20 2d 2d  ilding KitDLL --
14b0: 0a 09 09 23 23 20 74 68 65 79 27 72 65 20 6a 75  ...## they're ju
14c0: 73 74 20 74 69 6e 79 20 73 74 75 62 73 20 61 6e  st tiny stubs an
14d0: 79 77 61 79 0a 09 09 72 6d 20 2d 66 20 6b 69 74  yway...rm -f kit
14e0: 20 72 75 6e 6b 69 74 0a 09 66 69 0a 0a 09 65 78   runkit..fi...ex
14f0: 69 74 20 30 0a 29 20 7c 7c 20 65 78 69 74 20 31  it 0.) || exit 1
1500: 0a 0a 65 78 69 74 20 30 0a                       ..exit 0.